/***
 * Excerpted from "Domain-Driven Design Using Naked Objects",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/dhnako for more book information.
***/
@SuppressWarnings("unchecked")
@Hidden
public <T extends PersonRole> T getRole(Class<T> roleType) {
    for(PersonRole role: getRoles()) {
        if (roleType.isAssignableFrom(role.getClass())) {
            return (T) role;
        }
    }
    return null;
}
@Hidden
public boolean hasRole(Class<? extends PersonRole> roleType) {
    return getRole(roleType) != null;
}
